/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.java8.handson;

import com.dao.PersonDao;
import com.pojo.NameId;
import com.pojo.Person;
import java.util.DoubleSummaryStatistics;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

/**
 *
 * @author manikandan15785
 */
public class LambdaExample {
   static PersonDao dao=PersonDao.getInstance();
    public static void main(String[] args) {
        List<Person> listOfPerson=dao.getPersons();
        listOfPerson.forEach(System.out::println);
        listOfPerson.forEach(e->System.out.println(e));
        listOfPerson.forEach(
                e->
                {
                    e.setData(e.getData()*10);
                    System.out.println(e);
                }
        );
        double sum=listOfPerson.stream().collect(Collectors.summingDouble(Person::getData));
        System.out.println(sum);
        DoubleSummaryStatistics doubleSummaryStatistics= listOfPerson.stream().mapToDouble(Person::getData).summaryStatistics();
        System.out.println(doubleSummaryStatistics.getMin());
        System.out.println(doubleSummaryStatistics.getMax());
        System.out.println(doubleSummaryStatistics.getSum());
        System.out.println(doubleSummaryStatistics.getAverage());
        System.out.println(doubleSummaryStatistics.getCount());
        
        Map<String,List<Person>> byGender=listOfPerson.stream().collect(Collectors.groupingBy(Person::getSex));
        System.out.println(byGender);
        
        Map<String,String> nameAndAge=listOfPerson.stream().collect(Collectors.toMap(Person::getName,Person::getSex));
        System.out.println(nameAndAge);
        
       List<Person> filteredPerson=listOfPerson.stream().filter(x-> x.getData()>700).collect(Collectors.toList());
       filteredPerson.forEach(System.out::println);
       
       List<String> names=listOfPerson.stream().map((e)->e.getName()).collect(Collectors.toList());
       String stringNames=names.stream().collect(Collectors.joining(","));
       System.out.println(stringNames);
       
       List<String> genders=listOfPerson.stream().map((e)->e.getSex()).distinct().collect(Collectors.toList());
       genders.forEach(System.out::println);
       
       List<NameId> nameIds=listOfPerson.stream().map(e->{
           NameId nameId=new NameId();
           nameId.setId(e.getId());
           nameId.setName(e.getName());
           return nameId;
       }).collect(Collectors.toList());
        System.out.println(nameIds);
       
    }
}
