/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.java8.handson;

import java.util.Arrays;
import java.util.List;
import java.util.function.Supplier;
import java.util.stream.IntStream;

/**
 *
 * @author manikandan15785
 */
public class WorkingWithInterface {
    @FunctionalInterface
    interface Functional{
        void method();
    }
    
    @FunctionalInterface
    public interface FunctionalDefaultMethods {
        void method();
        default void defaultMethod() {
            System.out.println("Default implementation");
        }
    }
    
     @FunctionalInterface
    public interface FunctionalStaticMethods {
        void method();
        static void defaultMethod() {
            System.out.println("Default implementation");
        }
    }
    
     public static void main(String[] args) {
//        Functional impl=()->{ System.out.println("my implementation"); };
//        FunctionalDefaultMethods functionalDefaultMethods=()->{ System.out.println("my implementation"); };
//        FunctionalStaticMethods functionalStaticMethods=()->{ System.out.println("my implementation"); };
        
        Car car = Car.create( Car::new );
        List< Car > cars = Arrays.asList( car );
        cars.forEach(Car::running);
        
         

    }

     
       
}
class Car {
    public static Car create( final Supplier< Car > supplier ) {
        return supplier.get();
    } 
        
    public void running() {   
        System.out.println( "Repaired " + this.toString() );
    }
}
